/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   Background.h
 * Author: tg
 *
 * Created on April 26, 2016, 5:39 PM
 */

#ifndef BACKGROUND_H
#define BACKGROUND_H

#include "Image.h"
#include <map>


class Background {
private:
    long int neighbour_indices_ [26];
    struct PeakArea {
        int imagenumber;
        int h;
        int w;
        unsigned short val;
    } peakArea_;
    std::map<unsigned short, std::vector<PeakArea> > labelledPeaks_;
    
    std::vector <short> peaks3D_;

    //! recursively search neighbouing pixels in stack
    void searchNeighbours(const size_t index, const short label);
    
    std::string inputdir_;
    std::string outbase_;
    int from_, to_;
    float bgsigmalevel_;
    // images must have identical dimensions
    unsigned short width_;
    unsigned short height_;
    std::vector<Image<unsigned short>> imagestack_;
    std::vector <float> stacknoise_;
    
    // calculate the stacknoise as average across all images
    void noise();
    
    // remove isolated pixels
    void despeckle();
    
    //! create inputfilename frame_value_i.bin
    std::string infile (unsigned short i);
    //! create output filename base_000i.cbf
    std::string outfile (const std::string& base, unsigned short i, unsigned short spacer);

 public:
    Background(const std::string& inputdir, const std::string& outbase, unsigned short from, unsigned short to, float bgsigmalevel);
    ~Background();

    // substract n + k* sqrt(n) of noise from data
    void denoise (float ksigma);
    
    // convolute with Sobel matrix
    void sobel();
    
    
    // write images to png
    void writeImages ();
    
};

#endif /* BACKGROUND_H */

