/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   Converter.h
 * Author: tg
 *
 * Created on July 12, 2016, 4:48 PM
 */

#ifndef CONVERTER_H
#define CONVERTER_H

#include <string>
#include <vector>

#include "Image.h"

class Converter {
private:
    std::string inputdir_;
    std::string basename_;
    std::string inroot_;
    unsigned short from_, to_;
    bool verbose_;
    unsigned short width_, height_;
    bool crosscorrect_;
    
    
    //! create inputfilename frame_value_i.bin
    std::string infile (unsigned short i) const;
    //! create output filename base_000i.cbf
    std::string outfile (const std::string& base, unsigned short i, unsigned short spacer) const;
    
    //! flag dead pixels
    void flag (Image<int>& image);

    void print_missing(const std::vector<bool>& conv_flags) const;
    
    //! find the quad where data are;
    // char getquad () const;
    
    void px2mm (unsigned short x, unsigned short y, float& xmm, float& ymm) const;
    
public:
    // convert a continuous series of files, maintain numbering
    Converter(const std::string& inputdir, const std::string& basename, 
            const std::string& inroot, unsigned short from, unsigned short to, 
            bool verbose);
    // convert exactly one file
    Converter(const std::string& infile, const std::string& outfile, 
    bool verbose, const short crosscale=1);

    ~Converter() {}
    
    void convert(unsigned short sum, const short crosscale);
    
    // print XDS SEGMENT information for detector
    void segment() const;

};

#endif /* CONVERTER_H */

