/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   Parser.cpp
 * Author: tg
 * 
 * Created on January 6, 2016, 3:44 PM
 */

#include "Parser.h"

#include "Parser.h"
#include "myExceptions.h"
#include "usage.h"
#include <iostream>

/**
 * Sets default values, e.g. don't refine orgx/orgy
 * @param argc
 * @param argv
 */
Parser::Parser(int argc, const char* const argv[]) :
verbose_(false), 
        version_(false), 
        root_ ("frame_value_"), 
        inputfile_ (""),
        from_(1), 
        to_(0), 
        indir_("./"), 
        bg_sigma_level_(0.0),
        crosscale_ (3),
        sum_(1) {
    for (int i = 1; i < argc; ++i) {
        std::string option = argv[i];
        if (option.substr(0, 2) == "-h" || option.substr(0, 2) == "-?") {
            usage();
            throw myExcepts::Usage("Help message");
            return;
        }

        // verbose output
        if (option.substr(0, 2) == "-v") {
            verbose_ = true;
            continue;
        }

        //Version request
        if (option.substr(0, 2) == "-V") {
            version_ = true;
            break;
        }

        if (getoption (option, "-o", output_, i, argc, argv)) continue;
        if (getoption (option, "-f", inputfile_, i, argc, argv)) continue;
        if (getoption (option, "-r", root_, i, argc, argv)) continue;
        if (getoption (option, "-d", indir_, i, argc, argv)) continue;
        if (getoption (option, "-x", xdsinp_, i, argc, argv)) continue;
        
        
//        // output file (basename, in case a series)
//        if (option.substr(0, 2) == "-o") {
//            if (option.length() > 2) {
//                std::string fn = option.substr(2, option.length());
//                output_ = fn;
//                continue;
//            } else {
//                if (i + 1 >= argc) {
//                    usage();
//                    throw myExcepts::Usage("");
//                }
//                output_ = argv[i + 1];
//                ++i;
//                continue;
//            }
//        }
//        
//        //! input file (single file conversion)
//        if (option.substr(0, 2) == "-f") {
//            if (option.length() > 2) {
//                std::string fn = option.substr(2, option.length());
//                inputfile_ = fn;
//                continue;
//            } else {
//                if (i + 1 >= argc) {
//                    usage();
//                    throw myExcepts::Usage("");
//                }
//                inputfile_ = argv[i + 1];
//                ++i;
//                continue;
//            }
//        }
//        
//        // root name for input files 
//        if (option.substr(0, 2) == "-r") {
//            if (option.length() > 2) {
//                std::string fn = option.substr(2, option.length());
//                root_ = fn;
//                continue;
//            } else {
//                if (i + 1 >= argc) {
//                    usage();
//                    throw myExcepts::Usage("");
//                }
//                root_ = argv[i + 1];
//                ++i;
//                continue;
//            }            
//        }
//        
//        //! directory of input files
//        if (option.substr(0, 2) == "-d") {
//            if (option.length() > 2) {
//                std::string fn = option.substr(2, option.length());
//                indir_ = fn;
//                continue;
//            } else {
//                if (i + 1 >= argc) {
//                    usage();
//                    throw myExcepts::Usage("");
//                }
//                indir_ = argv[i + 1];
//                ++i;
//                continue;
//            }
//        }

//        //! XDS.INP file to read parameters
//        if (option.substr(0, 2) == "-x") {
//            if (option.length() > 2) {
//                std::string fn = option.substr(2, option.length());
//                xdsinp_ = fn;
//                continue;
//            } else {
//                if (i + 1 >= argc) {
//                    usage();
//                    throw myExcepts::Usage("");
//                }
//                xdsinp_ = argv[i + 1];
//                ++i;
//                continue;
//            }
//        }
        
        //! convert a range of files
        if (option.substr(0, 2) == "-c") {
            if (option.length() > 2) {
                std::string fn = option.substr(2, option.length());
                range(fn);
                continue;
            } else {
                if (i + 1 >= argc) {
                    usage();
                    throw myExcepts::Usage("");
                }
                range(argv[i + 1]);
                ++i;
                continue;
            }
        }
        //! background substract by averaging through k
        if (option.substr(0, 2) == "-b") {
            std::string convertee;
            if (option.length() > 2) {
                convertee = option.substr(2, option.length());
            } else {
                if (i + 1 >= argc) {
                    usage();
                    throw myExcepts::Usage("");
                }
                convertee = argv[i + 1];
                ++i;
            }
            std::istringstream inp (convertee);
            inp >> bg_sigma_level_;
            if (inp.fail()) {
                std::cout << "*** Error: Cannot convert " << convertee
                        << " to integer for background range\n";
                usage();
                throw myExcepts::Usage ("Conversion of command line parameter");
            }
                continue;
        }

        //! correction factor for inner crosse (at Pisa: 1, at CINA: 3)
        if (option.substr(0, 2) == "-X") {
            std::string convertee;
            if (option.length() > 2) {
                convertee = option.substr(2, option.length());
            } else {
                if (i + 1 >= argc) {
                    usage();
                    throw myExcepts::Usage("");
                }
                convertee = argv[i + 1];
                ++i;
            }
            std::istringstream inp (convertee);
            inp >> crosscale_;
            if (inp.fail()) {
                std::cout << "*** Error: Cannot convert " << convertee
                        << " integer for cross pixel correction\n";
                usage();
                throw myExcepts::Usage ("Conversion of command line parameter");
            }
                continue;
        }

        if (option.substr(0, 2) == "-s") {
            std::string convertee;
            if (option.length() > 2) {
                convertee = option.substr(2, option.length());
            } else {
                if (i + 1 >= argc) {
                    usage();
                    throw myExcepts::Usage("");
                }
                convertee = argv[i + 1];
            }
            std::istringstream inp (convertee);
            inp >> sum_;
            if (inp.fail()) {
                std::cout << "*** Error: Cannot convert " << convertee
                        << " to integer for summing images\n";
                usage();
                throw myExcepts::Usage ("Conversion of command line parameter");
            }
                ++i;
                continue;
        }

        if (option.at(0) == '-') {
            std::cout << "Unknown option string " << option << std::endl;
            usage();
            throw myExcepts::Usage(option.c_str());
        }
    }
    if (version_) return;
    
    // sanity checks
    if (output_.empty()) {
        std::cout << "*** Error: Empty output filename. Please provide one.\n";
        usage();
        throw myExcepts::Usage("Empty output filename");
    }

    if (!inputfile_.empty()) {
         return;
    }
    
    if (from_ > to_) {
        std::cout << "*** Error: Inverted image range, " << to_ << "<" << from_
                << '\n';
        usage();
        throw myExcepts::Usage("Inverted image range");
    }
}

Parser::~Parser() {
}

/**
 * Expect a string of either a single number, or a range of the form 
 * a:b or a-b and set first_ to a and last_ to b
 * @param range_string
 */
void Parser::range(const std::string& range_string) {
    char c;
    std::istringstream conv (range_string);
    conv >> from_ >> c >> to_;
    if (conv.fail()) {
        std::cout << "*** Error: Interpretation of " << range_string 
                << " as two numbers in the form of a:b or a-b failed.\n"
                << "    Please specify range as in 3-200 or 17:123\n"
                << "    without spaces.\n";
        throw myExcepts::Usage ("Range string");
    }
    
    
}

template <typename T> bool Parser::getoption(const std::string& option, 
        const std::string& opt, T& optval, int& idx, int argc, 
        const char* const argv[]) {

    // root name for input files 
    if (option.substr(0, 2) == opt) {
        if (option.length() > 2) {
            std::string fn = option.substr(2, opt.length());
            optval = fn;
            return true;
        } else {
            if (idx + 1 >= argc) {
                usage();
                throw myExcepts::Usage("");
            }
            optval = argv[idx + 1];
            ++idx;
            return true;
        }
    } else return false;
}
