/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   Parser.h
 * Author: tg
 *
 * Created on July 12, 2016, 4:20 PM
 */

#ifndef PARSER_H
#define PARSER_H

#include <string>
#include <vector>

/**
 * Simplified command line parser
 * @param orig
 */
class Parser {
private:
    bool verbose_;
    bool version_;
    unsigned short from_, to_;
    std::string root_;
    std::string inputfile_;
    std::string output_;
    std::string xdsinp_;
    std::string indir_;
    float bg_sigma_level_;
    short crosscale_;
    unsigned short sum_;

    void range (const std::string& range_string);
    template <typename T> bool getoption (const std::string& option, 
        const std::string& opt, T& optval, int& idx, int argc, 
        const char* const argv[]);
    
public:
    Parser(int argc, const char* const argv[]);
    ~Parser();
    
    bool verbose() const { return verbose_; }
    bool version() const { return version_; }
    unsigned short from() { return from_; }
    unsigned short to () { return to_;}
    std::string root() const { return root_; }
    std::string inputfile() const { return inputfile_; }
    std::string output() const { return output_; }
    std::string xdsinp() const { return xdsinp_; }
    std::string framedir() const {return indir_; }
    float bgsigmalevel() const { return bg_sigma_level_; }
    short crosscale() const { return crosscale_; }
    unsigned short sum() const { return sum_; }
    
};

#endif /* PARSER_H */

