/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   main.cpp
 * Author: tg
 *
 * Created on April 18, 2016, 4:23 PM
 */

#include <sstream>
#include <iostream>

#include "Image.h"
#include "io.h"
#include "Background.h"
#include "Parser.h"
#include "Converter.h"
#include "defines.h"
#include "usage.h"

/*
 * read in TIMEPIX bin format and write out CBF file
 * large pixels per quad: tripled, value divided by 3
 */
int main(int argc, char** argv) {
    
    Parser parser (argc, argv);
    if (parser.version()) {
        std::cout << "*** This is the program timepix to convert Timepix/Medipix binary format to cbf\n";
        version();
        return 0;
    }
    
    //! single  input output
    if (!parser.inputfile().empty()) {
        Converter converter (parser.inputfile(), parser.output(), 
                parser.verbose(), parser.crosscale());
        return 0;
    }
    std::cout << "---> Timepix converting files " << parser.from() 
            << " to " << parser.to() << '\n'
            << "    output filename set to " << parser.output() << '\n'
            << "    summing " << parser.sum() << " images\n";
    
    Converter converter(parser.framedir(), parser.output(), parser.root(), parser.from(), 
            parser.to(), parser.verbose());
    converter.convert(parser.sum(), parser.crosscale());
    // converter.segment();
    
    if (parser.bgsigmalevel() > 0) {
        Background bg(parser.framedir(), parser.output(), parser.from(), parser.to(), parser.bgsigmalevel());
        // bg.sobel();
        bg.denoise(parser.bgsigmalevel());
        bg.writeImages ();        
    }
    return 0;
    
    
    
    
//    
//    
//    Image<unsigned short> myimage (IO::in::raw(argv[1]));
//    
//    myimage.centre(40, cx, cy);
//
//    TestImg::data2greypng("debug_testimage.png", myimage.data(), myimage.width(), myimage.height());
//    
//    IO::out::txt("image.data", myimage);
    
    return 0;
}

